from django.shortcuts import render, redirect
# from django.views.generic import ListView, DetailView,  DeleteView, UpdateView, CreateView
from django.views import View, generic
from django.db import connection as conn


# Create your views here.
class Dashboard(generic.TemplateView):
    template_name = "layout/layout.html"
    # @method_decorator(login_required(login_url='maps:login'))
        
    def get(self, request):
        with conn.cursor() as prov:
            prov.execute("SELECT json_build_object('geometry', ST_AsGeoJSON(geom :: geometry) :: json) from geo_prov_kab where kabupaten = 'OGAN KOMERING ULU'")
            prov_res = prov.fetchall()
        # print(prov_res)
        context = {
        'title':'NA - Dashboard',
        'prov_res': prov_res[0]}
        return render (request, self.template_name, context)
    
class SearchLocation(generic.TemplateView):
    template_name = "maps/maps.html"
    
    # @method_decorator(login_required(login_url='maps:login'))
    def get(self, request):
        return redirect("apps:dashboard")
        
    def post(self, request):        
        # self.search_kab = request.POST.get('polykab')
        # self.search_desa = request.POST.get('polydes')
        
        # batas_desa = []
        
        # with conn.cursor() as poly_k:
        #     poly_k.execute("SELECT json_build_object('type', 'Feature', 'administrasi',('kode_desa_dagri', kelurahan, kecamatan, kota, provinsi), 'geometry', ST_AsGeoJSON(geom :: geometry) :: json) from data_desa_new where kelurahan = '%s' and kota = '%s'" % (self.search_desa, self.search_kab))
        #     poly_des = poly_k.fetchall()
        #     # print(poly_prov)
        #     poly_desa = []
        #     for i in poly_des:
        #         poly_desa.append(i[0])
        
        # with conn.cursor() as c_buildings:
        #     c_buildings.execute("select json_build_object('type', 'Feature', 'properties', (buildings.id, buildings.name, 'None', 'None'), 'administrasi',(buildings.address_1, 'undefined', buildings.address_3, buildings.provinsi, 'None'), 'geometry', ST_AsGeoJSON(buildings.geom :: geometry) :: json) from geo_settle_update buildings join data_desa_new desa on st_intersects(desa.geom ,buildings.geom) where desa.kelurahan = '%s' AND desa.kota = '%s'"% (self.search_desa, self.search_kab))                    
        #     polygon_buildings = c_buildings.fetchall()
            
        #     polbang = []        
        #     for i in polygon_buildings:
        #         i[0]['properties']['f2'] = i[0]['properties']['f2'].replace("'"," ")
        #         polbang.append(i[0])
                
        # with conn.cursor() as c_trees:
        #     c_trees.execute("select json_build_object('type', 'Feature', 'properties', (buildings.id, buildings.name, buildings.information, buildings.sumber), 'administrasi',(buildings.address_1, buildings.address_2, buildings.address_3, buildings.provinsi, buildings.no), 'geometry', ST_AsGeoJSON(buildings.geom :: geometry) :: json) from geom_master buildings join data_desa_new desa on st_intersects(desa.geom ,buildings.geom) where desa.kelurahan = '%s' AND desa.kota = '%s' and buildings.sumber = 'osm'"% (self.search_desa, self.search_kab))
        #     polygon_trees = c_trees.fetchall()
            
        #     poltrees = []        
        #     for i in polygon_trees:
        #         i[0]['properties']['f2'] = i[0]['properties']['f2'].replace("'"," ")
        #         i[0]['properties']['f2'] = i[0]['properties']['f2'].replace('"','')
        #         poltrees.append(i[0])
                
        # with conn.cursor() as jalan:
        #     jalan.execute("SELECT json_build_object ('type', 'Feature', 'properties', ( jl.id, jl.name ), 'geometry', ST_AsGeoJSON ( st_intersection(d.geom, jl.geom) :: geometry ) :: json ) FROM geo_roads jl JOIN data_desa_new d ON st_intersects ( d.geom, jl.geom )  WHERE d.kelurahan = '%s' AND d.kota = '%s'"% (self.search_desa, self.search_kab))
        #     data_jalan = jalan.fetchall()
            
        #     line_jalan = []
        #     for i in data_jalan:
        #         i[0]['properties']['f2'] = i[0]['properties']['f2'].replace("'"," ")
        #         line_jalan.append(i[0])
        
        # lat, lng, zoom = setview(polbang, poltrees)
                
        return render (request, self.template_name, {"title":"NA - CheckByPolygon"})#,"polbang":polbang,"poltrees":poltrees,'jumlah_bangunan' : len(polbang)+len(poltrees), 'batas_co':batas_desa, 'search_by': 'address', 'address':f'{self.search_desa},{self.search_kab}', 'poly_desa':poly_desa, 'lat':lat, 'lng':lng, 'zoom':zoom, 'line_jalan':line_jalan})
    
class SearchRadius(generic.TemplateView):
    template_name = "maps/maps.html"
    
    # @method_decorator(login_required(login_url='maps:login'))
    def get(self, request):
        return redirect("apps:dashboard")
        
    def post(self, request):        
        # self.latM = request.POST.get('latM')
        # self.lonM = request.POST.get('lonM')
        # self.radius = request.POST.get('radius')
        # zon = ''
        
        # with conn.cursor() as c:
        #     c.execute("select json_build_object('type', 'Feature', 'properties', (id, name, information, sumber), 'administrasi',(address_1, address_2, address_3, provinsi, no), 'geometry', ST_AsGeoJSON(geom :: geometry) :: json) from geom_master where ST_DWithin ( buildings.geom, 'SRID=4326;POINT(%.10s %.10s)', %s) and sumber = 'gen'" % (self.lonM, self.latM, self.radius))
        #         # c.execute("SELECT json_build_object ('type', 'Feature', 'properties', ( buildings.id, buildings.name ), 'geometry', ST_AsGeoJSON ( buildings.geom :: geometry ) :: json), json_build_object ('type', 'Feature', 'properties', ( osm.id, osm.name ), 'geometry', ST_AsGeoJSON ( osm.geom :: geometry ) :: json) FROM geo_settle AS buildings JOIN geo_build_osm AS osm ON ST_Intersects(osm.geom,buildings.geom) WHERE ST_DWithin ( buildings.geom, 'SRID=4326;POINT(%.10s %.10s)', %s) AND ST_DWithin ( osm.geom, 'SRID=4326;POINT(%.10s %.10s)', %s) AND osm.is_delete=1 AND buildings.is_delete=1" % (self.lonM, self.latM, self.radius, self.lonM, self.latM, self.radius))
        #     polygon = c.fetchall()
        #     polbang = []        
        #     for i in polygon:
        #         polbang.append(i[0])
                        
        # with conn.cursor() as c_trees:
        #     c_trees.execute("SELECT json_build_object('type', 'Feature', 'properties', (id, name, information, sumber), 'administrasi',(address_1, address_2, address_3, provinsi, no), 'geometry', ST_AsGeoJSON(geom :: geometry) :: json) FROM geom_master WHERE ST_DWithin(geom, Geography(ST_MakePoint(%.10s, %.10s)), %s) and sumber = 'osm'" % (self.lonM, self.latM, self.radius))
        #     polygon_trees = c_trees.fetchall()
            
        #     poltrees = []        
        #     for i in polygon_trees:
        #         poltrees.append(i[0])

        return render (request, self.template_name, {"title":"NA - CheckByRadius"})#, "polbang":polbang, "poltrees":poltrees, 'jumlah_bangunan' : len(polbang)+len(poltrees), 'batas_co':zon, 'search_by': 'radius', 'address':'None'})

import re
class SearchPolygon(generic.TemplateView):
    template_name = "maps/maps.html"

    # @method_decorator(login_required(login_url='maps:login'))
    def get(self, request):
        return redirect("apps:dashboard")
        
    def post(self, request):        
        # zon = [[[]]]
        # self.coordinatZone = request.POST.get('coordinateZone')
        
        # ZoneCo = self.coordinatZone.replace('"','')        
        # zon = list(ZoneCo.split(","))
        # # for i in zon:
        # with conn.cursor() as c_trees:
        #     c_trees.execute("SELECT json_build_object('type', 'Feature', 'properties', (id, 'name', 'information', 'sumber'), 'administrasi',(address_1, address_2, address_3, provinsi, 'no'), 'geometry', ST_AsGeoJSON(geom :: geometry) :: json) FROM geo_settle WHERE st_intersects(geom,'SRID=4326;POLYGON((%s))') and sumber = 'osm'"% ZoneCo)
        #     polygon_trees = c_trees.fetchall()
            
        #     polygon_trees_geom = []
        #     poltrees = []  
        #     nnnn = []            
        #     for i in polygon_trees:
        #         i[0]['properties']['f2'] = i[0]['properties']['f2'].replace("'"," ")
        #         poltrees.append(i[0])
        #         polygon_trees_geom.append(tuple(i[0]['geometry']['coordinates'][0][0]))
                
        #         mmm = []      
        #         multip = ""
        #         for x, y in i[0]['geometry']['coordinates'][0][0]:
        #             multip += (f'{x} {y}, ')
                    
        #         mmm.append(multip)

                
        #         qqq = []
        #         zzz = ""
        #         for xc in mmm:
        #             zzz += xc[:-2]
        #         qqq.append(zzz)

        #         # mnmn = ""
        #         # cc = []
        #         # for k in nnn[:-1]:
                
        #         #     mnmn += k
        #         #     cc.append(k)
        #         # # nnnn.append(k)
        #         # listTo = ' '.join([str(elem) for elem in cc]) 
                

                
        #     # p1 = polystr.replace("[","(")
        #     # p2 = p1.replace("]",")")
            
        # with conn.cursor() as c_buildings:
        #     c_buildings.execute("SELECT json_build_object('type', 'Feature', 'properties', (id, 'name', 'information', 'sumber'), 'administrasi',(address_1, address_2, address_3, provinsi, 'no'), 'geometry', ST_AsGeoJSON(geom :: geometry) :: json) FROM geo_settle WHERE st_intersects(geom,'SRID=4326;POLYGON((%s))')"% ZoneCo)
        #     polygon_buildings = c_buildings.fetchall()
            
        #     polbang = []        
        #     for i in polygon_buildings:
        #         i[0]['properties']['f2'] = i[0]['properties']['f2'].replace("'"," ")
        #         polbang.append(i[0])
        
        # with conn.cursor() as jalan:
        #     jalan.execute("""SELECT json_build_object ('type', 'Feature', 'properties', ( id, name ), 'geometry', ST_AsGeoJSON ( st_intersection(geom, 'SRID=4326;POLYGON((%s))') :: geometry ) :: json ) FROM geo_roads WHERE st_intersects(geom,'SRID=4326;POLYGON((%s))')"""% (ZoneCo, ZoneCo))
        #     data_jalan = jalan.fetchall()
            
        #     line_jalan = []
        #     for i in data_jalan:
        #         i[0]['properties']['f2'] = i[0]['properties']['f2'].replace("'"," ")
        #         line_jalan.append(i[0])
                
        # lat, lng, zoom = setview(polbang, poltrees)
        
        return render (request, self.template_name, {"title":"NA - CheckByPolygon"})#,"polbang":polbang,"poltrees":poltrees,'jumlah_bangunan' : len(polbang)+len(poltrees), 'batas_co':zon, 'search_by': 'polygon', 'address':'None', 'lat':lat, 'lng':lng, 'zoom':zoom, 'line_jalan':line_jalan})
